<script lang="ts">
import NoticeBox from './notice-box.vue';
import MrktoForm from './form.vue';
import { Speakers } from '~/components/seventeen/index.vue';

export default {
  name: 'CopyForm',
  components: {
    MrktoForm,
    NoticeBox,
    Speakers,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
};
</script>

<template>
  <SlpContainer
    :id="data.metadata ? data.metadata.id_tag : ''"
    class="slp-position-relative"
  >
    <div
      class="grid_container slp-mb-md-96 slp-mb-32"
      :class="{
        'grid_container--background': !data.without_bg,
        'grid_container--no-content': !data.subtitle,
        'grid_container--no-header': !data.header || data.no_header,
        'grid_container--background-sm': !data.subtitle,
      }"
      :data-slippers-scroll="data.metadata ? data.metadata.id_tag : ''"
    >
      <div
        v-if="data.header || data.subtitle"
        class="header_container"
        :class="{ 'slp-pt-md-64': !data.without_bg }"
        :data-aos="data.content_aos_animation"
        :data-aos-duration="data.content_aos_duration"
        :data-aos-offset="data.aos_offset"
      >
        <SlpTypography
          v-if="data.header"
          class="form_text__header"
          tag="h1"
          :variant="data.text_header || 'heading3-bold'"
          ><span v-html="$md.render(data.header)"></span>
        </SlpTypography>
        <SlpTypography
          v-if="data.subtitle"
          class="form_text__subtitle"
          tag="div"
          variant="heading4"
          ><span v-html="$md.render(data.subtitle)"></span
        ></SlpTypography>
      </div>
      <div
        class="form_text__container"
        :data-aos="data.content_aos_animation"
        :data-aos-duration="data.content_aos_duration"
        :data-aos-offset="data.aos_offset"
      >
        <SlpTypography
          v-if="data.content"
          class="content"
          tag="div"
          :variant="data.text_body || 'body1'"
          :class="{ 'slp-mt-96': !data.without_bg }"
        >
          <div v-html="$md.render(data.content)"></div>
        </SlpTypography>
        <div v-else class="content" :class="{ 'slp-mt-96': !data.without_bg }">
          <slot></slot>
        </div>
        <NoticeBox v-if="data.notice_box" :text="data.notice_box" />
        <!-- // Adding speakers cards for /seventeen page -->
        <Speakers
          v-if="data.gitlabSeventeenRelease"
          :data="data.gitlabSeventeenRelease"
        />
      </div>
      <MrktoForm
        :class="{ 'slp-pt-md-96': !data.without_bg }"
        :data="data.form"
        :data-aos="data.form_aos_animation"
        :data-aos-duration="data.form_aos_duration"
        :data-aos-offset="data.aos_offset"
      />
    </div>
  </SlpContainer>
</template>

<style scoped lang="scss">
.header_container {
  grid-area: header;
}

.grid_container {
  position: relative;
  display: grid;
  grid-template-columns: 1fr;
  grid-template-rows: 115px auto;
  grid-template-areas:
    'header'
    'form'
    'content';

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: 1fr 1fr;
    grid-template-areas:
      'header form'
      'content form';

    &--background {
      grid-template-rows: 300px auto;
    }
  }

  &--no-header {
    grid-template-rows: 0;

    .content:deep {
      h3 {
        font-size: 24px;
        font-weight: 600;
        letter-spacing: -0.6px;
        line-height: 32px;
        margin-bottom: 0;
      }
      p:first-of-type {
        margin-top: $spacing-16;
      }
    }
  }

  &--background {
    grid-template-rows: 250px auto;

    &:before {
      content: '';
      background-color: #f8f8f8;
      height: 340px;
      width: 200vw;
      position: absolute;
      left: 0;
      top: 0;
      z-index: -1;
      transform: translateX(-50%);
    }

    &-sm:before {
      height: 240px !important;
    }

    &--no-content {
      grid-template-rows: 150px auto;

      @media (min-width: $breakpoint-lg) {
        grid-template-rows: 200px auto;
      }
    }
  }
}

.form_text__header,
.form_text__subtitle {
  padding: 0 $spacing-16;
}

.form_text__subtitle {
  margin-bottom: $spacing-96;
}

.header_container {
  text-align: center;
  @media (min-width: $breakpoint-lg) {
    text-align: left;
  }

  .form_text__header {
    margin: 0 0 $spacing-16 0;
  }
}

.form_text__container {
  grid-area: content;

  .content {
    padding: 0 $spacing-16;
  }

  .content:deep {
    ul {
      list-style: inherit;
      padding-left: $spacing-24;
      font-size: 16px;
      line-height: 24px;

      li {
        margin-bottom: 1rem;
        padding-left: $spacing-8;
      }
    }

    p {
      margin-bottom: $spacing-24;
    }

    h2 {
      margin-bottom: $spacing-16;
      font-size: 23px;
      line-height: 28px;
    }
  }

  h3 {
    font-size: 23px;
    font-weight: 400;
    line-height: 1.25;
    max-width: 750px;
  }

  p {
    font-size: 16px;
    margin-bottom: $spacing-16;
  }
}

.form_text__container {
  @media (max-width: $breakpoint-lg) {
    margin-bottom: 3rem;
  }
}
</style>
